Imports System
Imports System.IO
Imports System.Data
Imports System.Data.SqlClient
Imports System.Web.UI.WebControls

Partial Class Delete_sql
    Inherits System.Web.UI.Page
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        ' When the page loads we get UserID from saved session variable and set the gridview to show the last page
        If Page.IsPostBack = False Then
            Try
                ' Get the UserID.
                txtUserID.Text = Convert.ToString(Session("UserID"))

                ' Set page index to the last page.
                GridView1.PageIndex = Int32.MaxValue

            Catch ex As Exception
                Response.Write(ex.Message)
            End Try
        End If
    End Sub
    Protected Sub DeletOnePostButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles DeletOnePostButton.Click

        ' Delete one row in the Users table where the UserID is equal to the active user
        Try
            Dim ConnString As String = ConfigurationManager.ConnectionStrings("ConnectionString").ToString()
            Dim sql As String = "DELETE FROM Users WHERE UserID = @UserID"

            ' The Using block is used to call dispose (close) automatically even if there are an exception.
            Using cn As New SqlConnection(ConnString), _
                  cmd As New SqlCommand(sql, cn)
                cmd.Parameters.Add("@UserID", SqlDbType.Int).Value = txtUserID.Text

                ' Open the connection
                cn.Open()

                ' Execute the DELETE statement.
                cmd.ExecuteNonQuery()

            End Using
        Catch ex As Exception
            Response.Write(ex.Message)
        End Try
    End Sub
    Protected Sub DeleteCarsButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles DeleteCarsButton.Click

        ' Delete cars in the Cars table where the Year is equal to the entered year in the textbox
        Try
            Dim ConnString As String = ConfigurationManager.ConnectionStrings("ConnectionString").ToString()
            Dim sql As String = "DELETE FROM Cars WHERE Year = @Year"

            ' The Using block is used to call dispose (close) automatically even if there are an exception.
            Using cn As New SqlConnection(ConnString), _
                  cmd As New SqlCommand(sql, cn)
                cmd.Parameters.Add("@Year", SqlDbType.Int).Value = txtCarYear.Text

                cn.Open()
                cmd.ExecuteNonQuery()

            End Using
        Catch ex As Exception
            Response.Write(ex.Message)
        End Try
    End Sub
    Protected Sub GridView1_RowCommand(ByVal sender As Object, ByVal e As GridViewCommandEventArgs)

        If e.CommandName = "Download" Then
            Dim xbrlFilUrl As String = (e.CommandArgument).ToString()

            ' Gives the user a save dialog to download the xbrlfile
            Response.Clear()
            Response.ContentType = "Application/xbrl"
            Response.AppendHeader("Content-Disposition", "attachment; filename=Revisionsberattelse.xbrl")
            Response.WriteFile(xbrlFilUrl)
            Response.Flush()
            Response.Close()
        End If
        If e.CommandName = "Delete" Then

            ' We get the URL of the RevisionFile from the CommandArgument but have to find out the FileID as well
            Dim RevisionFile As String = (e.CommandArgument).ToString()

            ' Code to get the FileID from the GridView
            Dim lb As ImageButton = CType(e.CommandSource, ImageButton)
            Dim gvRow As GridViewRow = lb.BindingContainer
            Dim FileID As String = GridView1.DataKeys(gvRow.RowIndex)(0).ToString()

            ' Delete row in database and delete the xbrl-file that is saved on our webserver
            Try
                Dim ConnString As String = ConfigurationManager.ConnectionStrings("ConnectionString").ToString()
                Dim sql As String = "DELETE FROM Revision WHERE RevisionID = @RevisionID"

                ' The Using block is used to call dispose (close) automatically even if there are an exception.
                Using cn As New SqlConnection(ConnString), _
                      cmd As New SqlCommand(sql, cn)
                    cmd.Parameters.Add("@RevisionID", SqlDbType.Int).Value = FileID

                    cn.Open()
                    cmd.ExecuteNonQuery()

                    ' Delete xbrl-file
                    Dim FileToDelete As FileInfo = New FileInfo(Server.MapPath(RevisionFile))
                    If FileToDelete.Exists Then
                        FileToDelete.Delete()
                    End If

                    FileToDelete = Nothing
                    RevisionFile = Nothing

                End Using
            Catch ex As Exception
                Response.Write(ex.Message)
            End Try
        End If
    End Sub
End Class
